*     Program: STARTUP.PRG  SAMPLE INTERFACE CODE FOR CUSTOM HELP SYSTEMS
*    Software: The Ultimate Help Maker @ dDoctor
*   Developer: Frank "dFox" Picchione, dDoctor
*            : Expert Advisor to Ashton-Tate
*            : dBase II, III, IV, Clip, QS, Arago, FP 2.0/2.5 DOS/WIN/Mac
*   Copyright: All Rights Reserved.  1994
*     Company: Data Processing Rare Birds
*     Address: 5642 Richmond Ave, Garden Grove Calif 92645
*   FAX/Phone: (714) 891-8230
*         CIS: 73633,2504
*            :
* Description: Pop Up Dialog Module to provide user with the capability
*            : to outline all system/application help requirements to
*            : the screen and field level(s).
*     Release: Beta Version, 01/11/94; CompuServe (FoxForum) 2/16/94
*   Trademark: Browza is a trademark of Data Processing Rare Birds
*----------------------------------------------------------------------

PARAMETER Calling_Procedure, Field_Variable, Mode_ && Help Active (ON/OFF)

DO HELPMAKR.APP WITH Calling_Procedure, Field_Variable
*  EXTERNAL PROCEDURE STARTUP

RETURN && [DO NOT REMOVE]  This is a "stopper" for call from your
*                          application and sample code for your
*                          procedure file and/or main program to
*                          demonstrate setting up the help procedure.

*----------------------------------------------------------------------
* NAMING CONVENTIONS AND HELP MAKER RESOURCES THAT CAN NOT BE DUPLICATED:

* WINDOW NAME PREFIX:  Hm_ (EG, Hm_DIALOG FOR DIALOG CONTROL SCREEN)
* 
* PROCEDURE FILE:  HELPPROC.PRG
*
* DEVELOPER SET ON/POP-UP DEBUG TOOL BOX:  TOOLBOX.PRG

* PLEASE REPORT ANY OTHER UNUSUAL PROBLEM DUE TO POSSIBLE NAME CONFLICTS.
* ALL MEMVARS USED IN HELP MAKER HAVE BEEN DESIGNATED PRIVATE.
*----------------------------------------------------------------------

* SET UP SECTION (ONLY EXECUTED ONCE @ ON KEY LABEL REFERENCE)

* IN HOUSEKEEPING SET UP SECTION OF YOUR PROCEDURE, YOU WANT TO SET THE
* HELP COMMANDS TO "POINT" TO YOUR CUSTOM APP HELP DATABASE FILE

* ILLUSTRATION CODE:  HELP DATABASE FILE IS NAMED APP_HELP.DBF W/.FPT

  IF NOT USED("APP_HELP")
    SELECT 0
    USE APP_HELP
  ELSE
    SELECT APP_HELP
    SET ORDER TO TAG PROCEDURE
  ENDIF

  ON KEY LABEL F1 DO CUSTOM_HELP WITH PROGRAM(),VARREAD()


* NOTE:  ON "OPENING" THE HELP DATABASE FILE (APP_HELP), WITH THE
*        FOXPRO-STYLE HELP METHOD, THE FILE WILL HAVE TO BE OPENED
*        AND CLOSED CONSTANTLY EVERYTIME F1 IS DEPRESSED/SELECTED.
*        THIS IS BECAUSE THE KEY LOOK UP FOR PROCEDURE AND OBJECT
*        NAME MUST TAKE PLACE BEFORE THE TOPIC CAN BE SET.

*        IN CONCLUSION, IT IS VERY SIMILAR TO XBASE QUICKSILVER
*        @ GET SYNTAX HAVING A HELP EXTENSION FOR AN OBJECT.
*        YOU WOULD NOT POPULATE THE ENTIRE APP PROCEDURES WITH
*        "SET TOPIC TO" COMMANDS AND FURTHERMORE, IT ENHANCES
*        PROBLEMS RELATED TO SYSTEM MODIFICATIONS AND MAINTENANCE.


*----------------------------------------------------------------------
*     FOR FOXPRO-STYLE HELP, USING TOPIC/HELP TEXT DISPLAY METHOD
*----------------------------------------------------------------------

PROCEDURE CUSTOM_HELP && FOXPRO-STYLE HELP
PARAMETER Calling_Procedure,Field_Variable
  
  PRIVATE cObject,cTopic
  cObject =ALLTRIM(Calling_Procedure)+ALLTRIM(Field_Variable)
  SELECT APP_HELP
  SET ORDER TO TAG PROCEDURE
  SEEK (cObject)
  IF NOT FOUND() AND Field_Variable #SPACE(10)
    cObject =ALLTRIM(Calling_Procedure)+SPACE(10)
    SEEK (cObject)
    IF NOT FOUND()
      cObject =Calling_Procedure
      SEEK (cObject)
    ENDIF
  ENDIF
  IF NOT FOUND()
    cObject =" Object/Screen:  "+ALLTRIM(cObject)+" "
    =CONFIRM("  No Help was made for Object/Screen...  OK?  ","Y","Y",;
      cObject,0)
    RETURN .F.
  ENDIF
  cTopic =Topic
  USE
  SET TOPIC TO cTopic
  HELP
  SET HELP TO
  USE APP_HELP
  SET ORDER TO TAG PROCEDURE 
  RETURN
  
  
*----------------------------------------------------------------------
*     FOR TRADITIONAL WINDOW POP-UP STYLE, OPEN HELP DATABASE FILE
*----------------------------------------------------------------------

PROCEDURE CUSTOM_HELP  
PARAMETER Calling_Procedure,Field_Variable
  
  PRIVATE cObject
  cObject =ALLTRIM(Calling_Procedure)+ALLTRIM(Field_Variable)
  SELECT APP_HELP
  SEEK (cObject)
  IF NOT FOUND() AND Field_Variable #SPACE(10)
    cObject =ALLTRIM(Calling_Procedure)+SPACE(10)
    SEEK (cObject)
    IF NOT FOUND()
      cObject =Calling_Procedure
      SEEK (cObject)
    ENDIF
  ENDIF
  IF NOT FOUND()
    cObject =" Object/Screen:  "+ALLTRIM(cObject)+" "
    =CONFIRM("  No Help was made for Object/Screen...  OK?  ","Y","Y",;
      cObject,0)
    RETURN .F.
  ENDIF
  PRIVATE cTopic,lcColor,lcAttributes,lcFooter,lCursor
  lcFooter =" "+ALLTRIM(Footer)+" "
  IF ISCOLOR()
    lcColor =TRIM(Say_Colors)+",";
            +TRIM(Get_Colors)+",";
            +TRIM(Border_Col)+",,";
            +TRIM(Title_Col)
  ELSE
    lcColor ="W/N,N/W,N/W,W/N"
  ENDIF
  IF Shadow
    lcAttributes =" SHADOW "
  ELSE
    lcAttributes =Null
  ENDIF
  IF Float
    lcAttributes =lcAttributes + " FLOAT "
  ENDIF
  IF Dbl_Line
    lcAttributes =lcAttributes + " DOUBLE "
  ENDIF
  cTopic =" "+ALLTRIM(Topic)+" "
  IF EMPTY(Footer)
    DEFINE WINDOW HELP_WIN FROM Ulr,Ulc TO Lrr,Lrc;
      COLOR &lcColor &lcAttributes TITLE cTopic
  ELSE
    DEFINE WINDOW HELP_WIN FROM Ulr,Ulc TO Lrr,Lrc;
      COLOR &lcColor &lcAttributes TITLE cTopic FOOTER lcFooter
  ENDIF
  lCursor =SET("CURSOR")="ON"
  SET CURSOR OFF
  nRows =Lrr - Ulr -1
  nCols =Lrc - Ulc -1
  oCols =SET("MEMOWIDTH")
  SET MEMOWIDTH TO (nCols)
  IF MEMLINES(mHelp_Text) <=nRows
    ACTIVATE WINDOW HELP_WIN
    @ 0,1 SAY mHelp_Text SIZE nRows,nCols
    =INKEY(0)
  ELSE
    MODIFY MEMO mHelp_Text WINDOW HELP_WIN
  ENDIF
  RELEASE WINDOW HELP_WIN
  SET MEMOWIDTH TO (oCols)
  IF lCursor
    SET CURSOR ON
  ENDIF
